#############################################################################
# defines.mk (part of XVin)                                                 #
#############################################################################
# this makefile contains only definitions
# these definitions are common to ALL platforms
#
# specific defines that depend on the platform are in specific makefiles
# (win32.mk / linux.mk / macos.mk)
#
# the choice of system/platform is done in 'platform.mk'
#
# this file, 'defines.mk' should not be modified.
# it is included by 'platform.mk' which is the file that can be tuned to
# match your system needs
#
#############################################################################
# do not edit this file
#############################################################################



#############################################################################
# below we import definitions specific to each system                       #
#############################################################################
ifeq ($(SYSTEM),WIN32)
	XVIN := $(FFTW3STUFF) bin/xvin.exe
	include $(XVIN_DIR)win32.mk
else
ifeq ($(SYSTEM),MACOS)
	XVIN := bin/xvin
	include $(XVIN_DIR)macos.mk
else
ifeq ($(SYSTEM),LINUX)
	XVIN := bin/xvin
	include $(XVIN_DIR)linux.mk
else
# 	return echo "no system defined"
endif
endif
endif


#############################################################################
# below we give definitions specific to each external library we use        #
#############################################################################
ifdef ALLEGRO_DIR
	ALLEGRO_BIN  = $(ALLEGRO_DIR)/bin
	ALLEGRO_INC  = `allegro-config --cflags`
	ALLEGRO_LIB  = `allegro-config --libs`
else
	ALLEGRO_BIN  = $(strip $(GNU_LIBS_DIR))/bin
	ALLEGRO_INC  = `allegro-config --cflags`
	ALLEGRO_LIB  = `allegro-config --libs`
endif
ifdef FREETYPE_DIR
	FREETYPE_INC = `freetype-config --cflags` -I/mingw32/include/freetype2
	FREETYPE_LIB = `freetype-config --libs`
else
	FREETYPE_INC = `freetype-config --cflags` -I/mingw32/include/freetype2
	FREETYPE_LIB = `freetype-config --libs`
endif
ifdef GSL_DIR
	GSL_INC      = `gsl-config --cflags`
	GSL_LIB      = `gsl-config --libs`
else
	GSL_INC      = `gsl-config --cflags`
	GSL_LIB      = `gsl-config --libs`
endif
ifdef GTK_DIR
	GTK_INC      = `pkg-config gtk+-3.0 --cflags` #DB pkg in path
	GTK_LIB      = `pkg-config gtk+-3.0 --libs`
else
	GTK_INC      = `pkg-config gtk+-3.0 --cflags`
	GTK_LIB      = `pkg-config gtk+-3.0 --libs`
endif

# following line is to avoid error because allegro-config doesn't exist on win32:
ifeq ($(SYSTEM),WIN32)
     ifdef ALLEGRO_DIR
           ALLEGRO_INC  = $(strip $(ALLEGRO_DIR))/include/
     else
           ALLEGRO_INC  = $(strip $(GNU_LIBS_DIR))/include/
     endif
     ALLEGRO_LIB = -lalleg44
endif

#############################################################################
# below we give definitions common to all systems                           #
#############################################################################

# below is the archive name for all plugins source
ZIPALL = plsrc

# below is eventually the memory checker flag
ifeq ($(MEMCHECK),FORTIFY)
MEMCHECK_FLAGS = -DFORTIFY
endif

# below we add a useful warning flag:

CPU_FLAGS  += $(WARNING_FLAGS) $(DEBUG_FLAGS) -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE

#tv : temporary disconned this
#ifneq ($(SYSTEM),WIN32)
#CPU_FLAGS += -fstack-protector-all -ftrapv
#CXX_FLAGS += -fstack-protector-all -ftrapv
#LD_FLAGS += -Wl,-z,relro -Wl,-z,now
#endif

# below is the (generic) list of directories containing headers:
ifeq ($(PLATFORM),MVSC)
XVIN_INC       = /I./include /I./include/xvin /I./include/plug-ins -I./src/menus/plot/treat/
else
XVIN_INC       = -I./include -I./include/xvin  -I./include/generated
#/include -I./include/xvin -I./include/plug-ins -I./src/menus/plot/treat/ -I../../include/ -I../../include/xvin
endif

# below we build the complete list of include dirs:
INC_FLAGS = $(MY_INC) $(XVIN_INC) $(GTK_INC)
# about the line above :
# MY_INC is defined in 'platform.mk', it contains additional dirs to search in
# XVIN_INC is defined above in the present file

# following are for plug'ins compilation:
PLUG_INS_INC = $(MY_INC) $(subst -I./,-I../../,$(XVIN_INC)) $(GTK_INC)
PLUG_INS_LIB = -L$(XVIN_DIR)lib -L$(XVIN_DIR)bin -L$(strip $(GNU_LIBS_DIR))/lib

# cflags to compile xvin objects
ifeq ($(PLATFORM),MVSC)
CFLAGS 		= /c $(CPU_FLAGS) /D$(XV_TARGET) $(INC_FLAGS) $(PLATFORM_FLAGS) \
                                             $(LINKING_OPTION) $(MEMCHECK_FLAGS)
else
CFLAGS 		= -c $(CPU_FLAGS) -D$(XV_TARGET) $(INC_FLAGS) $(PLATFORM_FLAGS) \
                                             $(LINKING_OPTION) $(MEMCHECK_FLAGS) $(GTK_LIB)
endif
# cflags to icompile plug-ins objects :
PCFLAGS 	= -c $(CPU_FLAGS) -D$(XV_TARGET) $(PLATFORM_FLAGS) \
					$(PLUGIN_LINKING_OPTION) $(MEMCHECK_FLAGS) $(PLUG_INS_INC)
